bison-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Test suite: Synclines


From: Akim Demaille
Subject: Test suite: Synclines
Date: 09 Jul 2002 12:04:44 +0200
User-agent: Gnus/5.0808 (Gnus v5.8.8) XEmacs/21.4 (Honest Recruiter)

Index: ChangeLog
from  Akim Demaille  <address@hidden>

        * tests/synclines.at (AT_SYNCLINES_COMPILE): New.
        (AT_TEST_SYNCLINE): Adjust to unusual GCC outputs.
        Reported by R Blake <address@hidden>.

Index: THANKS
===================================================================
RCS file: /cvsroot/bison/bison/THANKS,v
retrieving revision 1.42
diff -u -u -r1.42 THANKS
--- THANKS 25 Jun 2002 12:05:38 -0000 1.42
+++ THANKS 9 Jul 2002 10:03:49 -0000
@@ -41,6 +41,7 @@
 Per Allansson           address@hidden
 Peter Hámorský          address@hidden
 Piotr Gackiewicz        address@hidden
+R Blake                 address@hidden
 Raja R Harinath         address@hidden
 Richard Stallman        address@hidden
 Robert Anisko           address@hidden
Index: tests/synclines.at
===================================================================
RCS file: /cvsroot/bison/bison/tests/synclines.at,v
retrieving revision 1.4
diff -u -u -r1.4 synclines.at
--- tests/synclines.at 11 Jun 2002 20:16:05 -0000 1.4
+++ tests/synclines.at 9 Jul 2002 10:04:00 -0000
@@ -18,6 +18,22 @@
 
 AT_BANNER([[User Actions.]])
 
+
+# AT_SYNCLINES_COMPILE(FILE)
+# --------------------------
+# Compile FILE expecting an error, and save in the file stdout the normalized
+# output.
+m4_define([AT_SYNCLINES_COMPILE],
+[AT_CHECK([$CC $CFLAGS $CPPFLAGS $1 -c], 1, [], [stderr])
+# In case GCC displays column information, strip it down.
+#
+#   input.y:4:2: #error "4"    or input.y:4.2: #error "4"
+# =>
+#   input.y:4: #error "4"
+#
+AT_CHECK([[sed 's/^\([^:]*:[^:.]*\)[.:][^:]*:\(.*\)$/\1:\2/' stderr]], 0, 
[stdout])
+])
+
 # AT_TEST_SYNCLINE(TITLE, INPUT, ERROR-MSG)
 # -----------------------------------------
 # Check that compiling the parser produced from INPUT cause GCC
@@ -25,23 +41,34 @@
 m4_define([AT_TEST_SYNCLINE],
 [AT_SETUP([$1])
 
-# I'm not sure I can find a generic scheme to check the location
-# of an error, so we keep this for GCC only.
-AT_CHECK([test "$GCC" = yes || exit 77])
+# It seems impossible to find a generic scheme to check the location
+# of an error.  Even requiring GCC is not sufficient, since for instance
+# the version modified by Apple:
+#
+# | Reading specs from /usr/libexec/gcc/darwin/ppc/2.95.2/specs
+# | Apple Computer, Inc. version gcc-934.3, based on gcc version 2.95.2
+# | 19991024 (release) configure:2124: $? = 0
+#
+# instead of:
+#
+# | input.y:2: #error "2"
+#
+# it reports:
+#
+# | input.y:2: "2"
+# | cpp-precomp: warning: errors during smart preprocessing, retrying in basic 
mode
+
+AT_DATA([syncline.c],
+[[#error "1"
+]])
 
-AT_DATA([[input.y]],
-[$2])
+AT_SYNCLINES_COMPILE([syncline.c])
+AT_CHECK([[test "`cat stdout`" = 'syncline.c:1: @%:@error "1"' || exit 77]])
 
+AT_DATA([[input.y]], [$2])
 AT_CHECK([bison input.y -o input.c])
-AT_CHECK([$CC $CFLAGS $CPPFLAGS input.c -c], 1, [], [stderr])
-# In case GCC displays column information, strip it down.
-#
-#   input.y:4:2: #error "4"    or input.y:4.2: #error "4"
-# =>
-#   input.y:4: #error "4"
-#
-AT_CHECK([[sed 's/^\([^:]*:[^:.]*\)[.:][^:]*:\(.*\)$/\1:\2/' stderr]],
-         0, [$3])
+AT_SYNCLINES_COMPILE([input.c])
+AT_CHECK([cat stdout], 0, [$3])
 AT_CLEANUP
 ])
 



reply via email to

[Prev in Thread] Current Thread [Next in Thread]